-- shows logo on library initialization
{$DEFINE SHOW_LOGO}
{***************************************************************************}
-- with this definition on initialization state debug information printing
-- on screen
-- also VbeErrorMsg array defined
{$DEFINE DEBUG}
{***************************************************************************}
-- define this definition, if vertexes in yours polygons always go in
-- counter-clockwise direction
{$DEFINE VERTEXES_IN_CLOCKWISE_DIRECTION}

{***************************************************************************}
-- with this definition you can perform z-clipping. By default it defined,
-- but it will cause slower clipping
{$DEFINE Z_CLIPPING}
-- Don't remove it. This needed for correct clipping
{$IFDEF Z_CLIPPING}
     {$DEFINE CLIP_UPDATE_Z}
{$ENDIF}

-- this definitions defines what values must be updated
-- while clipping performed
{$DEFINE CLIP_UPDATE_Z}
{$DEFINE CLIP_UPDATE_UV}
{$DEFINE CLIP_UPDATE_COLOR}
{***************************************************************************}
-- with this definition drawing procedures perform checking, if destination
-- address is word (dword) aligned, so it can put words (dwords) fast.
-- usually it is faster than non-scan methods, but for very small polygons
-- it can make code slower. So, if your's program always draw object with
-- many small polygons, try to undefine this
{$DEFINE ALIGN_SCAN}
{***************************************************************************}
--this define maximal size of temporary array to hold coordinates while clipping
--Actually size used by this array will be MAX_TEMP_VERTEXES*SizeOf(TVertex3dFix)
--Normally, for temp vertex holding, maximal size of array will be
--  n*c  , where n is number of vertexes in yours polygon, and
-- c - number of sides in clipping rectangle (or box, if z-clipping performed)
CONST MAX_TEMP_VERTEXES=20;
