Procedure PutPix16(x,y:word;color:word; where:TPageType);
{  memW[Where.seg+x*2 + y*2*Where.SizeX]:=word(color);}
begin
  asm
   -- xor eax,eax
   -- xor edx,edx
    xor ebx,ebx
    mov ax,y
    mov dx,word ptr Where[4]
    mul edx

    mov edi,dword ptr Where
    mov bx,x
    add ebx,eax

    mov ax,word ptr color
    mov [edi+ebx*2],ax
  end;
end;
Function GetPix16(x,y:word; where:TPageType):word;
begin
  asm
    xor ebx,ebx
    mov ax,y
    mov dx,word ptr Where[4]
    mul edx

    mov edi,dword ptr Where
--    mov ebx,eax
    mov bx,x
    add ebx,eax

    mov ax,[edi+ebx*2]
  end;
end;

Procedure Line16(x1,y1,x2,y2,color:word;Where:TPageType);
   function sign(a:longint):longint;assembler;
      asm
        mov eax,a
        and eax,eax
        jns @@1
        jz  @@zero
        mov eax,-1
        jmp @@2
  @@zero:
        mov eax,0
        jmp @@2
  @@1:
        mov eax,1
  @@2:
      end;

var xlen,ylen,xStep,yStep:fixed;
    startX,startY,endX,endY,currX,currY:fixed;
    xstep2:fixed;
    {xdir,}ydir:longint;
    x,y:longint;
    offs:dword;
    temp:integer;
begin
  xlen:=abs(x2-x1)+1;
  ylen:=abs(y2-y1)+1;
  if xlen>ylen then begin
         -- go from right to left --
         if x2>x1 then begin
            temp:=x1;
            x1:=x2;
            x2:=temp;
            temp:=y1;
            y1:=y2;
            y2:=temp;
            {xdir:=-xdir;}
         end;

         ydir:=sign(y2-y1);
         {xdir:=sign(x2-x1);}
         xStep:=mFixedDiv(ylen shl 16,xlen shl 16);

         yStep:=Where.SizeX*ydir*2;
         asm
           cld

           mov edi,dword ptr Where  -- calculate offset of line begining
           sub eax,eax
           mov ax,y1
           sub ecx,ecx
           mov cx,word ptr Where[4]
           mul ecx
           mov cx,x1
           add eax,ecx

           lea edi,[edi+eax*2]

           mov edx,xStep
           mov ax,color

           mov ecx,xlen        -- put first dot

           sub edi,ecx
           sub edi,ecx

           xor bx,bx
           mov [edi+ecx*2],ax
           dec ecx

  @@drawHLine2:
           add     bx,dx       -- yFrac:=yFrac+yFracStep
           jnc     @@cont2
           add     edi,yStep   -- go to next line
  @@cont2:
           mov     [edi+ecx*2],ax
           dec ecx
           jnz @@DrawHLine2
--           loop    @@DrawHLine2
         end;
  end
  else if ylen>xlen then begin
         -- go from left to right --
         if x1>x2 then begin
            temp:=x1;
            x1:=x2;
            x2:=temp;
            temp:=y1;
            y1:=y2;
            y2:=temp;
         end;
         {xdir:=sign(x2-x1);}
         ydir:=sign(y2-y1);
         yStep:=mFixedDiv(xlen shl 16,ylen shl 16);

         xStep:=Where.SizeX*ydir*2-2;
         asm
           cld

           mov edi,dword ptr Where  -- calculate offset of line begining
           sub eax,eax
           mov ax,y1
           sub ecx,ecx
           mov cx,word ptr Where[4]
           mul ecx

           mov cx,x1
           add eax,ecx
           lea edi,[edi+eax*2]

           mov edx,yStep
           mov ecx,ylen
           lea edi,[edi+ecx*2]
           mov ax,color

           xor ecx,-1         -- neg ecx
           inc ecx

           xor     bx,bx
           mov [edi+ecx*2],ax   -- put first pixel
           inc ecx

   @@vloop:
           add bx,dx
           jnc @@cont
           add edi,2
   @@cont:
           add edi,xStep
           mov     [edi+ecx*2],ax
           inc ecx
           jnz @@vloop
         end;
  end;
end;

Procedure Bar16(x1,y1,x2,y2,color:word;Where:TPageType);
var
    tmp:word;
    yadd:longint;
    sizeX,SizeY:word;
begin
   if x1>x2 then begin
      tmp:=x1; x1:=x2; x2:=tmp;
      tmp:=y1; y1:=y2; y2:=tmp;
   end;
   SizeX:=x2-x1;
   SizeY:=abs(y2-y1)+1;
   if y1>y2 then yadd:=-(Where.SizeX+sizeX) else yadd:=(Where.SizeX-SizeX);

   asm
     mov edi,dword ptr Where  -- calculate starting offset

     sub eax,eax
     mov ax,y1

     sub ecx,ecx
     mov cx,word ptr Where[4]

     mul ecx             -- eax=y1*Where.SizeX
     mov cx,x1
     add eax,ecx         -- eax=x1+(y1*Where.SizeX)
     lea edi,[edi+eax*2] -- offs:=Where.seg+(x1+y1*Where.SizeX)*2

     mov ax,color
     shl eax,16
     mov ax,color

     mov cx,SizeX

     mov dx,cx
     mov bx,SizeY

     mov esi,yadd
     sal esi,1

     cld
   @@looper:
  -- draw horizontal line
     shr cx,1
     jnc @@FillD
     stosw
   @@FillD:
     rep stosd

     add edi,esi     -- offs+:=yadd
     mov cx,dx
     dec bx
     jnz @@looper
   @@nodraw:
   end;
end;
