Program Smoothing_Test;
Uses crt,mathtmt,svgalib,debug,strings;
TYPE
        FaceType = RECORD
                l1,l2,l3,l4 : byte;
        Nx,Ny,Nz,Nax,Nay,Naz:integer;    {angle.Use ArcCos to get real angle}
        end;
    Coords2d=record
              x,y:fixed;
             end;
const
   box=60;
   Number_coords=8;
   Number_Faces=6;
   CenterX:fixed=0;
   CenterY:fixed=0;
   CenterZ:fixed=0;
   ViewFactor:integer=box*5;
   first=true;
   last=false;
      TextSizeX=50;
      TextSizeY=50;

Type vscr=array[0..1024*768-1] of byte;
     aaa=array[0..111111] of word;
Var
        coords : array[0..NUMBER_COORDS-1] of TVertex3dFix;
        face : array[1..NUMBER_FACES] of FaceType;
    SinTable,CosTable:array[-360..360] of fixed;
    cBuffer:array[0..NUMBER_COORDS-1] of TVertex3dFix;
    Xang,Yang,Zang:integer;  {rotate angle}
    Light:byte;
    lx,ly,lz:integer;
    ch:char;

    vbuf,dbuf:^vscr;
    color:word;
    Poly:TPoly;
    VirtualBuffer:TPageType;

    tBegin,tEnd:dword;
    Timer:longint absolute $0000:$046C;
    frames:dword;
    ScreenSize:dword;

Procedure CopyScreen;assembler;
  asm
    cld
    mov edi,dbuf
    mov esi,vbuf
    mov ecx,320*200
--    mov ebx,pic
    mov ebx,dbuf
    lea esi,[esi+ecx*2]
    lea edi,[edi+ecx*2]
    lea ebx,[ebx+ecx*2]
    shr ecx,1
    xor ecx,-1
    inc ecx

  @@looper:
    mov eax,[ebx+ecx*4]
    mov edx,[esi+ecx*4]

    shr eax,1
    shr edx,1
    and eax,$7BEF7BEF
    and edx,$7BEF7BEF
    add edx,eax
    mov [edi+ecx*4],edx
    inc ecx
    jnz @@looper

{*****************}
    mov dx,$3da
@@waitoff:
    in al,dx
    test al,8
    jnz @@waitoff
@@waiton:
    in al,dx
    test al,8
    jz  @@waiton
{****************}
    mov dx,$3da
@@waitoff1:
    in al,dx
    test al,8
    jnz @@waitoff1
@@waiton1:
    in al,dx
    test al,8
    jz  @@waiton1
{****************}
    {copy to video memory}
    mov ecx,320*200/2
    mov esi,dbuf
    mov edi,LFB_seg
    rep movsd
  end;
Procedure ClearVBuf;assembler;
  asm
    cld
    --mov edi,[vbuf]
    mov edi,vbuf
    mov eax,0
    mov ecx,ScreenSize --320*200/4
    rep stosd
  end;

Procedure ClearScreen;assembler;
  asm
    cld
    mov edi,LFB_seg
    mov ecx,ScreenSize
    xor eax,eax
    rep stosd
  end;
Procedure InitTables;
var i:integer;
begin
   {setup faces. Make sure face keeps track of which coordinates it uses!}
        with face[1] do begin l1:=3; l2:=2; l3:=1; l4:=0; end;
        with face[2] do begin l1:=4; l2:=5; l3:=6; l4:=7; end;
        with face[3] do begin l1:=0; l2:=1; l3:=5; l4:=4; end;
        with face[4] do begin l1:=1; l2:=2; l3:=6; l4:=5; end;
        with face[5] do begin l1:=2; l2:=3; l3:=7; l4:=6; end;
        with face[6] do begin l1:=3; l2:=0; l3:=4; l4:=7; end;

{
     23      b0
   /     /     /     / 
  /     /     /     /           *x
 67     rg           /
    1ĺ0     gĺr       / 
   /     /     /     /       /  
  /     /     /     /       z   
 54/     0b/            y

}
    Coords[0].Color:=GetRgbColor(MaxRed,0,0);
    Coords[1].Color:=GetRgbColor(0,MaxGreen,0);
    Coords[2].Color:=GetRgbColor(0,0,MaxBlue);
    Coords[3].Color:=0;
    Coords[4].Color:=GetRgbColor(0,0,MaxBlue);
    Coords[5].Color:=0;
    Coords[6].Color:=GetRgbColor(MaxRed,0,0);
    Coords[7].Color:=GetRgbColor(0,MaxGreen,0);

    {setup coords for a box}
        with Coords[0] do begin x:=box; y:=box; z:=-box; end;
        with Coords[1] do begin x:=-box; y:=box; z:=-box;  end;
        with Coords[2] do begin x:=-box; y:=-box; z:=-box;end;
        with Coords[3] do begin x:=box; y:=-box; z:=-box; end;
        with Coords[4] do begin x:=box; y:=box; z:=box;  end;
        with Coords[5] do begin x:=-box; y:=box; z:=box;  end;
        with Coords[6] do begin x:=-box; y:=-box; z:=box; end;
        with Coords[7] do begin x:=box; y:=-box; z:=box;  end;

        for i:=0 to 7 do begin
            Coords[i].x:=mLongToFixed(Coords[i].x);
            Coords[i].y:=mLongToFixed(Coords[i].y);
            Coords[i].z:=mLongToFixed(Coords[i].z);
            Coords[i].color:=Coords[i].color*65536;
        end;

    for i:=-360 to 360 do begin
        SinTable[i]:=round(Sin(i*Pi/180)*65536);
        CosTable[i]:=round(Cos(i*Pi/180)*65536);
    end;

end;

function longmul(X, Y: Integer): Longint;inline($5A/$58/$f7/$EA);
function LongDiv(X: Longint; Y: Integer):Integer;inline($59/$58/$5A/$F7/$F9);

Function FaceShown(FaceNum:byte):boolean;
var
        a,b : longint;
begin
  with Face[FaceNum] do begin
        a := mFixedMul(cbuffer[l1].X-cbuffer[l2].X,cbuffer[l3].Y-cbuffer[l2].Y);
        b := mFixedMul(cbuffer[l1].Y-cbuffer[l2].Y,cbuffer[l3].X-cbuffer[l2].X);

        FaceShown := mRound(b-a) > 0;
        FaceShown:=true;
    Light:=mRound(b-a) div 280;{byte(LongDiv((a-b),63));}
  end;
end;

Procedure RotateCoordX(a:integer);
  var i,x1,y1,z1:fixed;
  begin
  for i:=0 to Number_Coords-1 do begin
    {rotate around x axis}

    y1:=mFixedMul(cbuffer[i].Y,CosTable[a])-mFixedMul(cbuffer[i].z,sintable[a]);
    z1:=mFixedMul(cbuffer[i].Y,Sintable[a])+mFixedMul(cbuffer[i].z,costable[a]);
    cBuffer[i].Y:=y1;
    cBuffer[i].Z:=z1;
  end;
  end;

Procedure RotateCoordY(a:integer);
  var i,x1,y1,z1:fixed;
  begin
  for i:=0 to Number_Coords-1 do begin
    x1:=round(cBuffer[i].x*Cos(a*pi/180))-round(cbuffer[i].z*sin(a*pi/180));
    z1:=round(cBuffer[i].x*Sin(a*pi/180))+round(cbuffer[i].z*cos(a*pi/180));

    cBuffer[i].X:=x1;
    cBuffer[i].Z:=z1;
  end;
  end;

Procedure RotateCoordZ(a:integer);
  var i,x1,y1,z1:fixed;
  begin
  for i:=0 to Number_Coords-1 do begin
    x1:=round(cBuffer[i].x*Cos(a*pi/180))-round(cbuffer[i].y*sin(a*pi/180));
    y1:=round(cBuffer[i].x*Sin(a*pi/180))+round(cbuffer[i].y*cos(a*pi/180));
    cBuffer[i].X:=x1;
    cBuffer[i].Y:=y1;
  end;
  end;

Procedure Perspective;
  var i:integer;
  begin
    for i:=0 to Number_coords-1 do begin
     cBuffer[i].x:=-mFixedDiv((cBuffer[i].x shl 8),(cBuffer[i].z+CenterZ- ViewFactor shl 16));
     cBuffer[i].y:=-mFixedDiv((cBuffer[i].y shl 8),(cBuffer[i].z+CenterZ - ViewFactor shl 16));
    end;
  end;

Procedure DrawCube;
  var i,j:byte;
      dstpoly:array[1..4*4] of TVertex3dFix;
  begin
    for i:=1 to Number_Faces do begin
      if FaceShown(i) then begin

         Poly[1].x:=(cbuffer[Face[i].l1].X+CenterX);
         Poly[1].y:=(cbuffer[Face[i].l1].Y+CenterY);
         Poly[1].z:=(cbuffer[Face[i].l1].Z+CenterZ);
         poly[1].color:=coords[Face[i].l1].color;

         Poly[2].x:=(cbuffer[Face[i].l2].X+CenterX);
         Poly[2].y:=(cbuffer[Face[i].l2].Y+CenterY);
         Poly[2].z:=(cbuffer[Face[i].l2].Z+CenterZ);
         poly[2].color:=coords[Face[i].l2].color;

         Poly[3].x:=(cbuffer[Face[i].l3].X+CenterX);
         Poly[3].y:=(cbuffer[Face[i].l3].Y+CenterY);
         Poly[3].z:=(cbuffer[Face[i].l3].Z+CenterZ);
         poly[3].color:=coords[Face[i].l3].color;

         Poly[4].x:=(cbuffer[Face[i].l4].X+CenterX);
         Poly[4].y:=(cbuffer[Face[i].l4].Y+CenterY);
         Poly[4].z:=(cbuffer[Face[i].l4].Z+CenterZ);
         poly[4].color:=coords[Face[i].l4].color;

         DECLARE var n:byte;
           begin
              n:=ClipPoly(@Poly,@DstPoly,4);
              if n<>0 then
                       DrawGoraudPoly16(@DstPoly,n,0,VirtualBuffer);
           end;

      end;

    end;
         CopyScreen;
         ClearVBuf;
  end;
var index:integer;
Const dir:shortint=1;
      currx:integer=0;
      curry:integer=0;
      dirx:integer=1;
      diry:integer=1;
var f:text;
    ff:file;
    x,y:integer;
    rgb:dword;
    b,g,r:byte;
    res:word;
    er:byte;
BEGIN
  writeln('initiating video mode ',hex(LFB320x200x16));
  writeln('Total LFB modes found: ',Total_LFB_Modes);
  readkey;
  er:=SetLFBMode(320,200,16);
  if (er<>0) then begin
     writeln('error initiating mode, error : ',VbeErrorMsg[er]);
     exit;
  end;
  InitTables;


  move(Coords,cbuffer,SizeOf(coords));
  lx:=0;
  ly:=0;
  lz:=0;
  frames:=0;

  VirtualBuffer:=VideoPage;
  CenterX:=(GetMaxX div 2) shl 16;
  CenterY:=(GetMaxY div 2) shl 16;
  ScreenSize:=ScrnSizeX*ScrnSizeY*BytesPerPixel div 4;

  GetMem(dbuf,ScrnSizeX*ScrnSizeY*BytesPerPixel);
  FillChar(dbuf^,ScrnSizeX*ScrnSizeY*BytesPerPixel,0);
  GetMem(vbuf,ScrnSizeX*ScrnSizeY*BytesPerPixel);
  VirtualBuffer.seg:=dword(vbuf);

  move(Coords,cbuffer,SizeOf(Coords));
  ClearVBuf;

  xang:=0; yang:=0; zang:=0;
--  SetZClippingRange(box,box+80+box-15);
  SetClipWindow(0,0,319,199);
  ClearScreen;
  tBegin:=Timer;
  repeat
     move(Coords,cbuffer,SizeOf(Coords));
     RotateCoordX(xang);
     RotateCoordY(yang);
     RotateCoordZ(zang);
     dec(xang);
     inc(yang);
     inc(zang);
     if xang>360 then xang:=0 else if xang<0 then xang:=360;
     if yang>360 then yang:=0 else if yang<0 then yang:=360;
     if zang>360 then zang:=0 else if zang<0 then zang:=360;
     Perspective;
     DrawCube;
     inc(frames);
     CenterX:=round((sin(xang/180*pi)*30+160) *65536);
     CenterY:=round((cos(yang/180*pi)*30+100) *65536);
     CenterZ:=round((cos(zang/180*pi)*100) *65536);
  until KeyPressed;
  tEnd:=Timer;
  readkey;
  FreeMem(vbuf,ScrnSizeX*ScrnSizeY*BytesPerPixel);
  FreeMem(dbuf,ScrnSizeX*ScrnSizeY*BytesPerPixel);
  CloseLFB;
  writeln('fps: ',frames/((tEnd-tBegin)/18.2):5:5);
END.