{ SCAN PROCEDURES FOR TEXTURE MAPPING ROUTINDES }

Procedure LeftSection;
  var Vrtx1,Vrtx2:integer;
      height:fixed;
--      prestep:fixed;
  begin
{$IFDEF VERTEXES_IN_CLOCKWISE_DIRECTION}
      Vrtx1:=LeftVrtx;
      Vrtx2:=LeftVrtx-1;
      if Vrtx2<1 then Vrtx2:=Num;
      LeftVrtx:=Vrtx2;
{$ELSE}
      Vrtx1:=LeftVrtx;
      Vrtx2:=LeftVrtx+1;
      if Vrtx2>Num then Vrtx2:=1;
      LeftVrtx:=Vrtx2;
{$ENDIF}
      {because we go from up to down, LeftSectionSize will always be >0}
      LeftSectionSize:=mRound(Poly^[Vrtx2].y)-mRound(Poly^[Vrtx1].y);
      if LeftSectionSize=0 then exit;
      {divide xlen by ylen}
      height:=Poly^[vrtx2].y-Poly^[vrtx1].y;
      CurrLeftX:=Poly^[vrtx1].x;
      LeftStepX:=mFixedDiv(Poly^[vrtx2].x-CurrLeftX,height);

--      prestep:=mFixedRound(Poly^[vrtx1].y)-Poly^[vrtx1].y;
--      CurrLeftX:=Poly^[vrtx1].x+mFixedMul(prestep,LeftStepX);

      CurrLeftTextX:=Poly^[vrtx1].u;
      CurrLeftTextY:=Poly^[vrtx1].v;
      LeftTextStepX:=mFixedDiv(Poly^[vrtx2].u-CurrLeftTextX,height);
      LeftTextStepY:=mFixedDiv(Poly^[vrtx2].v-CurrLeftTextY,height);
  end;

Procedure RightSection;
  var Vrtx1,Vrtx2:integer;
      height:fixed;
--      prestep:fixed;
  begin
{$IFDEF VERTEXES_IN_CLOCKWISE_DIRECTION}
      {if we come to vertex number 4 then NewVertex=vertex number 1}
      Vrtx1:=RightVrtx;
      Vrtx2:=RightVrtx+1;
      if Vrtx2>Num then Vrtx2:=1;
      RightVrtx:=Vrtx2;
{$ELSE}
      Vrtx1:=RightVrtx;
      Vrtx2:=RightVrtx-1;
      if Vrtx2<1 then Vrtx2:=Num;
      RightVrtx:=Vrtx2;
{$ENDIF}
      {because we go from up to down, RightSectionSize will always be >0}
      RightSectionSize:=mRound(Poly^[Vrtx2].y)-mRound(Poly^[Vrtx1].y);
      if RightSectionSize=0 then exit;
      {divide xlen by ylen}

      height:=Poly^[vrtx2].y-Poly^[vrtx1].y;
      CurrRightX:=Poly^[vrtx1].x;
      RightStepX:=mFixedDiv(Poly^[vrtx2].x-CurrRightX,height);

--      prestep:=mFixedRound(Poly^[vrtx1].y)-Poly^[vrtx1].y;
--      CurrRightX:=Poly^[vrtx1].x+mFixedMul(prestep,RightStepX);

      CurrRightTextX:=Poly^[vrtx1].u;
      CurrRightTextY:=Poly^[vrtx1].v;
      RightTextStepX:=mFixedDiv(Poly^[vrtx2].u-CurrRightTextX,height);
      RightTextStepY:=mFixedDiv(Poly^[vrtx2].v-CurrRightTextY,height);
  end;
